﻿if (not SoW_Clock) then -- 이 설정은 WTF 파일이 없는(최초 설치시) 경우에 설정되는 기본 사항입니다.
	SoW_Clock = {};
    SoW_Clock.MemSet = 0; -- 메모리 표시 종류 설정| 0=통합, 1=애드온, 2=와우기본UI
    SoW_Clock.MemSize = 25; -- 경고 시작할 메모리 용량
    SoW_Clock.TipSet = 1; -- 툴팁 표시 설정 | 0 = 메모리, 1 = CPU
    SoW_Clock.TipList = 30; -- 애드온 표시 리스트 갯수 설정
    SoW_Clock.TimeType = 0; -- 시간 표시 방법 설정 | 0 = 12시간 단위, 1 = 24시간 단위
    SoW_Clock.Scale = 1; -- 애드온의 크기 비율
    SoW_Clock.OClock = true; -- 정시 알림 소리 설정 | false = 미사용, true = 사용
    SoW_Clock.CleanTime = 5; -- 자동 메모리 정리 간격 | 단위는 분, 0일 경우 미사용
    SoW_Clock.CombatToolTipRemove = true; -- 전투중 툴팁 비활성화 | true = 비활성화, false = 활성화
    SoW_Clock.TimeSetType = 0; -- 0 = 클라이언트, 1 = 서버, 2 = UTC
    SoW_Clock.ShowType = 0; -- 0 = 시계 + 브로커, 1 = 브로커
    SoW_Clock.BrokerShowSet = 0; -- 0 = 시계, 1 = 프레임, 2 = 메모리, 3 = 핑, 4 = 프레임+메모리+핑, 5 = 겨손 타이머, 6 = 바요 타이머
    SoW_Clock.BattleGroundShowSet = 0; -- 0 = 모두, 1 = 바라딘 요새, 2 = 겨울 손아귀, 3 = 표시 안함
    SoW_Clock.BattleField = false; -- 전장 대기 알림 설정
    SoW_Clock.CPUUsage = false; -- CPU 사용 비율 표시 설정
end

local s = 0
local m = 0
local h = 0
local t = 0
local wc = 0
local tc = 0

function SoW_Ver()
  SoW_Clock.Version = "|cFFFFFF00 2.2.7|r";
  SoW_Clock.BuildDate = "|cFFFFFF00Build Date|r :|cFF00FFAA 12.01.27|r";
end

-- 시계 표시 관련
function SoW_TimeReturn(arg1, arg2, lua)
  if arg1 == 0 then
    if arg2 == 0 then
      if lua == "SoW_Clock.lua" then
        return date("%I:%M"), date("%p");
      elseif lua == "SoW_Clock_Broker.lua" then
        return date("%p %I:%M:%S");
      end
    elseif arg2 == 1 then
      h, m = GetGameTime()
      if h > 12 then
        h = h - 12
        if h < 10 then
          h = "0" .. h
        end
      end
      if m < 10 then
        m = "0" .. m
      end
      if lua == "SoW_Clock.lua" then
        return h .. ":" .. m, "--"
      elseif lua == "SoW_Clock_Broker.lua" then
        return h .. ":" .. m;
      end
    elseif arg2 == 2 then
      if lua == "SoW_Clock.lua" then
        return date("!%I") .. ":" .. date("!%M"), date("!%p");
      elseif lua == "SoW_Clock_Broker.lua" then
        return date("!%p") .. " " .. date("!%I") .. ":" .. date("!%M") .. ":" .. date("!%S");
      end
    end
  elseif arg1 == 1 then
    if arg2 == 0 then
      if lua == "SoW_Clock.lua" then
        return date("%H:%M"), date("%S");
      elseif lua == "SoW_Clock_Broker.lua" then
        return date("%p %H:%M:%S");
      end
    elseif arg2 == 1 then
      h, m = GetGameTime()
      if h < 10 then
        h = "0" .. h
      end
      if m < 10 then
        m = "0" .. m
      end
      if lua == "SoW_Clock.lua" then
        return h .. ":" .. m, "--"
      elseif lua == "SoW_Clock_Broker.lua" then
        return h .. ":" .. m;
      end
    elseif arg2 == 2 then
      if lua == "SoW_Clock.lua" then
        return date("!%H") .. ":" .. date("!%M"), date("!%p");
      elseif lua == "SoW_Clock_Broker.lua" then
        return date("!%p") .. " " .. date("!%H") .. ":" .. date("!%M") .. ":" .. date("!%S");
      end
    end
  end
end

function OClockNCleanTime()
  if( date("%M")*1 + date("%S")*1 == 0 and SoW_Clock.OClock == true ) then
    PlaySoundFile("Interface\\AddOns\\SoW_Clock\\Sound\\O'Clock.ogg")
  end
  
  if( SoW_Clock.CleanTime ~= 0 ) then
    if( date("%M")*1%SoW_Clock.CleanTime == 0 and date("%S")*1 == 0) then
      if( SoW_Clock.CombatToolTipRemove == true and InCombatLockdown() == nil ) then
        MemClear()
      end
    end
  end
end

function SoW_FPS_Return()
  local fps = GetFramerate();
  local fps_Color = "FFFFFF";
  if ( fps > 45 ) then
    fps_color = "00FF00";
  elseif ( fps > 30 ) then
  	fps_color = "66FF00";
  elseif ( fps > 20 ) then
  	fps_color = "BBFF00";
  elseif ( fps > 15 ) then
  	fps_color = "FFFF00";
  elseif ( fps > 10 ) then
  	fps_color = "FF9900";
  else
  	fps_color = "FF0000";
  end
  return string.format("|cFF%s%.0f|c00FFFFFFfps", fps_color, fps);
end

function SoW_Network_Status_Return(arg)
  local NetIn, NetOut, Latency = GetNetStats();
 	local Latency_Color = "FFFFFF";
 	if ( Latency > 300 ) then
 		Latency_Color = "FF0000";
 	elseif ( Latency > 250 ) then
 		Latency_Color = "FF9900";
 	elseif ( Latency > 200 ) then
 		Latency_Color = "FFFF00";
 	elseif ( Latency > 100 ) then
 		Latency_Color = "BBFF00";
 	elseif ( Latency > 50 ) then
 		Latency_Color = "66FF00";
 	elseif ( Latency > 10) then
 		Latency_Color = "00FF00";
  else
    Latency_Color = "00FFFF";
 	end
 	
 	if arg == 0 then
   	return string.format("|cFF%s%.0f|c00FFFFFFms", Latency_Color, Latency);
  elseif arg == 1 then
    return string.format("|c000000FFD|r %.1f|c00FFFFFFKB/s|r", NetIn) .. " " .. string.format("|c00FF0000U|r %.1f|c00FFFFFFKB/s|r", NetOut);
  elseif arg == 2 then
    return string.format("|c000000FFD|r %.1f|c00FFFFFFKB/s|r", NetIn) .. " " .. string.format("|c00FF0000U|r %.1f|c00FFFFFFKB/s|r", NetOut) .. " " .. string.format("|cFF%s%.0f|c00FFFFFFms", Latency_Color, Latency);
  end
end

function SoW_WoWMem_Return()
  local Mem_Size = 0;
  Mem_Size = gcinfo() / 1024;
  
  local Mem_Color = "FFFFFF";
  if ( Mem_Size > 80 ) then
  	Mem_Color = "FF0000";
  elseif ( Mem_Size > 60 ) then
  	Mem_Color = "FF7E00";
  elseif ( Mem_Size > 40 ) then
  	Mem_Color = "FFFF00";
  elseif ( Mem_Size > 35 ) then
  	Mem_Color = "AAFF00";
  elseif ( Mem_Size > 30 ) then
  	Mem_Color = "55FF00";
  else
  	Mem_Color = "00FF00";
  end
  
  return string.format("|cFF%s%.1f|c00FFFFFFMiB", Mem_Color, Mem_Size);
end


function SoW_BattleFieldTime(arg)
  if not IsInInstance() then
    local _, Zone_Name, Zone_Stat, _, Zone_WaitTime = GetWorldPVPAreaInfo(arg);
    local bt = Zone_WaitTime
    local bh, bm, bs = 0, 0, 0;
    if Zone_Stat then
      bt = bt - 7200;
      if ( bt >= 60 ) then
        bm = floor(bt/60)
        bs = bt%60
      else
        bs = bt
      end
      if bm < 10 then
        bm = "0" .. bm
      end
      if bs < 10 then
        bs = "0" .. bs
      end
      if arg == 1 then
        return "|TInterface\\Icons\\Ability_Parry:0:0:0:0|t" .. bm .. ":" .. bs .. " |TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t";
      elseif arg == 2 then
        return "|TInterface\\Icons\\Ability_Parry:0:0:0:0|t" .. bm .. ":" .. bs .. " |TInterface\\Icons\\Achievement_Zone_TolBarad:0:0:0:0|t";
      end
    else
      if ( bt >= 3600 ) then
        bh = floor(bt/3600)
        bm = floor((bt%3600)/60)
        bs = bt%60
      elseif ( bt >= 60 ) then
        bm = floor(bt/60)
        bs = bt%60
      else
        bs = bt
      end
      if bh < 10 then
        bh = "0" .. bh
      end
      if bm < 10 then
        bm = "0" .. bm
      end
      if bs < 10 then
        bs = "0" .. bs
      end
      if arg == 1 then
        return bh .. ":" .. bm .. ":" .. bs .. " |TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t";
      elseif arg == 2 then
        return bh .. ":" .. bm .. ":" .. bs .. " |TInterface\\Icons\\Achievement_Zone_TolBarad:0:0:0:0|t";
      end
    end    
  else
    return "|cFFFFFFFF전장 확인 불가|r|TInterface\\Icons\\INV_Misc_QuestionMark:0:0:0:0|t";
  end
end

function SoW_BattleFieldArarm()
  if not IsInInstance() then
    _, _, _, _, WG_WaitTime = GetWorldPVPAreaInfo(1);
    _, _, _, _, BH_WaitTime = GetWorldPVPAreaInfo(2);
    if BH_WaitTime == 300 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF바라딘 요새 전투까지 5분 남았습니다.|r");
    elseif BH_WaitTime == 180 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF바라딘 요새 전투까지 3분 남았습니다.|r");
    elseif BH_WaitTime == 120 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF바라딘 요새 전투까지 2분 남았습니다.|r");
    elseif BH_WaitTime == 60 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF바라딘 요새 전투까지 1분 남았습니다.|r");
      PlaySoundFile("Interface\\AddOns\\SoW_Clock\\Sound\\ReadyToGoSir.ogg")
    elseif BH_WaitTime == 0 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF바라딘 요새 전투가 시작되었습니다.|r")
      PlaySoundFile("Interface\\AddOns\\SoW_Clock\\Sound\\ReadyForNow.ogg")
    end

    if WG_WaitTime == 300 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF겨울손아귀 전투까지 5분 남았습니다.|r");
    elseif WG_WaitTime == 180 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF겨울손아귀 전투까지 3분 남았습니다.|r");
    elseif WG_WaitTime == 120 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF겨울손아귀 전투까지 2분 남았습니다.|r");
    elseif WG_WaitTime == 60 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF겨울손아귀 전투까지 1분 남았습니다.|r");
      PlaySoundFile("Interface\\AddOns\\SoW_Clock\\Sound\\ReadyToGoSir.ogg")
    elseif WG_WaitTime == 0 then
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF겨울손아귀 전투가 시작되었습니다.|r");
      PlaySoundFile("Interface\\AddOns\\SoW_Clock\\Sound\\ReadyForNow.ogg")
    end
  end
end

-- 메모리 정리
function MemClear()
  local old = gcinfo();
	collectgarbage( 'collect' );
	local new	= gcinfo();
	local erased	= old - new;
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : " .. MemTex(erased) .. " |cFFFFFFFF정리됨|r");
	ResetCPUUsage()
	return;
end

-- 시계 클릭 이벤트
function Click_Event(button)
  if (IsControlKeyDown() and IsShiftKeyDown()) then
	  ChatFrame1EditBox:SetText("/reloadui")
	  if not ChatFrame1EditBox:IsShown() then
	    ChatFrame1EditBox:Show();
	  end
  	ChatFrame1EditBox:HighlightText()

  elseif (IsShiftKeyDown() and button == "RightButton") then
    if not InterfaceOptionsFrame:IsShown() then
      InterfaceOptionsFrame:Show();
    else
      InterfaceOptionsFrame:Hide();
    end
	
	elseif (IsShiftKeyDown() and button == "LeftButton") then
		
	elseif (IsControlKeyDown() and button == "RightButton") then
	  if( StopwatchFrame:IsShown() )then
  	  StopwatchFrame:Hide();
  	else
  	  StopwatchFrame:Show();
	  end
	  
	elseif (button == "RightButton") then
	  if not IsAddOnLoaded("Blizzard_Calendar") then
      LoadAddOn("Blizzard_Calendar")
		end
		Calendar_Toggle()
		
	elseif (button == "LeftButton") then
	  MemClear()
	end
end

-- 툴팁 표시
function SoW_TooltipShow(ToolTipSet, ToolTipList, MemorySize)
  SoW_Ver()
  
  TimeManagerClockButton:Hide()
  
  if ToolTipList > 0 then
    if CalendarGetNumPendingInvites() > 0 then
      print("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |r미확인 일정이 있습니다.")
    end

    local memory, i, addons, total, CPUtotal, entry;
    
    GameTooltip:AddDoubleLine("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW C|cFFFFFFFFlock " .. SoW_Clock.Version, SoW_Clock.BuildDate);
    GameTooltip:AddLine("|cFFFFFFFF======================================================|r")
    
    if SoW_Clock.BattleGroundShowSet < 3 then
      s = 0
      m = 0
      h = 0
      t = 0
      wc = 0
      tc = 0
    
      if not IsInInstance() then
        local continentIndex = GetCurrentMapContinent()
        local zoneIndex = GetCurrentMapZone()
        -- 기존 위치 정보 저장
      
        if SoW_Clock.BattleGroundShowSet ~= 1 then
          local _, _, WG_Stat, WG_Queue, WG_WaitTime, WG_Enter = GetWorldPVPAreaInfo(1);
          -- 겨손 상황 정보 습득          
          -- 겨손 소유권 확인 시작
          SetMapZoom(4)
          -- 노스랜드 맵 지정
          local n = GetNumMapLandmarks()
          if n > 0 then 
            for i = 1, n do
              local name, _, nr = GetMapLandmarkInfo(i)
              if name == "겨울손아귀 호수" then
                wc = 1
                if nr == 46 then
                  GameTooltip:AddLine("|TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r를 |TInterface\\Addons\\SoW_Clock\\Icon\\Alliance.tga:0:0:0:0|t|c000000FF얼라이언스|r가 차지 하였습니다.|r")
                elseif nr == 48 then
                  GameTooltip:AddLine("|TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r를 |TInterface\\Addons\\SoW_Clock\\Icon\\Horde.tga:0:0:0:0|t|c00FF0000호드|r가 차지 하였습니다.|r")
                end
              end
            end
            if wc == 0 then
              GameTooltip:AddLine("|TInterface\\Icons\\INV_Misc_QuestionMark:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r의 소유상황을 확인할 수 없습니다.|r")
            end
          end
          -- 겨손 소유권 확인 종료
      
          -- 겨손 전투 상황 확인 시작
          if WG_Stat then
            GameTooltip:AddLine("|TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r를 차지하기 위한 |TInterface\\Icons\\Ability_Parry:0:0:0:0|t|c00999999전투|r가 진행 중입니다.|r")
          end
          -- 겨손 전투 상황 확인 종료

          -- 겨손 대기시간 확인 시작
          t = WG_WaitTime
          if ( t >= 3600 ) then
            h = floor(t/3600)
            m = floor((t%3600)/60)
            s = t%60
          elseif ( t >= 60 ) then
            m = floor(t/60)
            s = t%60
          else
            s = t
          end
          if WG_Stat then
            GameTooltip:AddDoubleLine("|TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t|cFFFFFFFF겨울손아귀|r |TInterface\\Icons\\Ability_Parry:0:0:0:0|t|c00999999전투|r 시간", "|TInterface\\Icons\\INV_Misc_PocketWatch_01:0:0:0:0|t |cFFFFFFFF" .. m .. "|r분 |cFFFFFFFF" .. s .. "|r초")
          else
            GameTooltip:AddDoubleLine("|TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t|cFFFFFFFF겨울손아귀|r |TInterface\\Icons\\Ability_Parry:0:0:0:0|t|c00999999전투|r 대기시간", "|TInterface\\Icons\\INV_Misc_PocketWatch_01:0:0:0:0|t |cFFFFFFFF" .. h .. "|r시간 |cFFFFFFFF" .. m .. "|r분 |cFFFFFFFF" .. s .. "|r초")
          end
          -- 겨손 대기시간 확인 종료
      
          --[[ 겨손 대기열/입장 가능 확인 시작
          if WG_Queue and WG_Enter then
            GameTooltip:AddLine("|TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r를 차지하기 위한 |TInterface\\Icons\\Ability_Parry:0:0:0:0|t|c00999999전투|r에 참여 가능합니다.|r")
          elseif WG_Enter then
            GameTooltip:AddLine("|TInterface\\Icons\\INV_EssenceOfWintergrasp:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r를 차지하기 위한 |TInterface\\Icons\\Ability_Parry:0:0:0:0|t|c00999999전투|r에 참여 가능합니다.|r")
          end
          -- 겨손 대기열/입장 가능 확인 종료]]--
        end
      
        if SoW_Clock.BattleGroundShowSet ~= 2 then
          s = 0
          m = 0
          h = 0
          local _, _, BH_Stat, BH_Queue, BH_WaitTime, BH_Enter = GetWorldPVPAreaInfo(2);
          -- 바라딘 요새 정보 습득
          -- 바라딘 요새 소유권 확인 시작
          SetMapZoom(2)
          -- 동부왕국 맵 지정
          local n = GetNumMapLandmarks()
          if n > 0 then 
            for i = 1, n do
              local name, _, nr = GetMapLandmarkInfo(i)
              if name == "바라딘 요새" then
                tc = 1
                if nr == 46 then
                  GameTooltip:AddLine("|TInterface\\Icons\\Achievement_Zone_TolBarad:0:0:0:0|t|cFFFFFFFF바라딘 요새|r를 |TInterface\\Addons\\SoW_Clock\\Icon\\Alliance.tga:0:0:0:0|t|c000000FF얼라이언스|r가 차지 하였습니다.|r")
                elseif nr == 48 then
                  GameTooltip:AddLine("|TInterface\\Icons\\Achievement_Zone_TolBarad:0:0:0:0|t|cFFFFFFFF바라딘 요새|r를 |TInterface\\Addons\\SoW_Clock\\Icon\\Horde.tga:0:0:0:0|t|c00FF0000호드|r가 차지 하였습니다.|r")
                end
              end
            end
            if tc == 0 then
              GameTooltip:AddLine("|TInterface\\Icons\\INV_Misc_QuestionMark:0:0:0:0|t|cFFFFFFFF바라딘 요새|r의 소유상황을 확인할 수 없습니다.|r")
            end
          end
          -- 바라딘 요새 소유권 확인 종료
      
          -- 바라딘 요새 전투 상황 확인 시작
          if BH_Stat then
            GameTooltip:AddLine("|TInterface\\Icons\\Achievement_Zone_TolBarad:0:0:0:0|t|cFFFFFFFF바라딘 요새|r를 차지하기 위한 |TInterface\\Icons\\Ability_DualWield:0:0:0:0|t|c00999999전투|r가 진행 중입니다.|r")
          end
          -- 바라딘 요새 전투 상황 확인 종료
      
          -- 바라딘 요새 대기시간 확인 시작
          t = BH_WaitTime
          if ( t >= 3600 ) then
            h = floor(t/3600)
            m = floor((t%3600)/60)
            s = t%60
          elseif ( t >= 60 ) then
            m = floor(t/60)
            s = t%60
          else
            s = t
          end
          if BH_Stat then
            GameTooltip:AddDoubleLine("|TInterface\\Icons\\Achievement_Zone_TolBarad:0:0:0:0|t|cFFFFFFFF바라딘 요새|r |TInterface\\Icons\\Ability_Parry:0:0:0:0|t|c00999999전투|r 시간", "|TInterface\\Icons\\INV_Misc_PocketWatch_01:0:0:0:0|t |cFFFFFFFF" .. m .. "|r분 |cFFFFFFFF" .. s .. "|r초")
          else
            GameTooltip:AddDoubleLine("|TInterface\\Icons\\Achievement_Zone_TolBarad:0:0:0:0|t|cFFFFFFFF바라딘 요새|r |TInterface\\Icons\\Ability_Parry:0:0:0:0|t|c00999999전투|r 대기시간", "|TInterface\\Icons\\INV_Misc_PocketWatch_01:0:0:0:0|t |cFFFFFFFF" .. h .. "|r시간 |cFFFFFFFF" .. m .. "|r분 |cFFFFFFFF" .. s .. "|r초")
          end
          -- 바라딘 요새 대기시간 확인 종료
        end
      
      SetMapZoom(continentIndex, zoneIndex, 1)
      
      elseif IsInInstance() then
        GameTooltip:AddLine("현 장소에서는 |TInterface\\Icons\\INV_Jewelry_Ring_66:0:0:0:0|t|cFFFFFFFF야외 전장|r의 |c00999999전투/소유|r 상황을 확인 할 수 없습니다.|r")
      end -- 야외전장 관련 함수
    
      GameTooltip:AddLine("|cFFFFFFFF======================================================|r")
    end
          
    GameTooltip:AddLine("|cFFFFCC00Left Click : |c00FFFFFF메모리 정리");
    GameTooltip:AddLine("|cFFFFCC00Right Click : |c00FFFFFF달력 열기");
    GameTooltip:AddLine("|cFFFFCC00Alt + Left Click : |c00FFFFFF시계 이동");
    GameTooltip:AddLine("|cFFFFCC00Ctrl + Right Click : |c00FFFFFF초시계 열기");
    GameTooltip:AddLine("|cFFFFCC00Shift + Right Click : |c00FFFFFF인터페이스 설정 열기");
    --GameTooltip:AddLine("|cFFFFCC00Alt + Shift + Click : |c00FFFFFFUI 재시작");

    GameTooltip:AddLine("|cFFFFFFFF======================================================|r")

    if SoW_Clock.CPUUsage then
      GameTooltip:AddDoubleLine("상위 |cFFFFFFFF" .. ToolTipList .. "|r개의 애드온", "메모리 사용량 / 메모리 비율 \| CPU 비율", 0, 0.6, 1, 1, 1, 0)

      GameTooltip:AddLine("|cFFFFFFFF======================================================|r")

      addons = {}
     	local number = 0
    	total = 0
    	CPUtotal = 0
    	UpdateAddOnCPUUsage()
      UpdateAddOnMemoryUsage()
      for i = 1, GetNumAddOns(), 1 do
        if GetAddOnMemoryUsage(i) > 0 then
          cpu = GetAddOnCPUUsage(i)
          memory = GetAddOnMemoryUsage(i)
          entry = {name = GetAddOnInfo(i), memory = memory, cpu = cpu}
          table.insert(addons, entry)
          total = total + memory
          CPUtotal = CPUtotal + cpu
        end
      end
      
      if ( ToolTipSet == 0 ) then
        table.sort(addons, function(a, b) return a.memory > b.memory end)
      else
        table.sort(addons, function(a, b) return a.cpu > b.cpu end)
      end
  
      for _,entry in pairs(addons) do
    		if number < ToolTipList then
    			if number < 9 then
    				GameTooltip:AddDoubleLine("|cFFFFFFFF  " .. number + 1 .. ". |cFFFFCC00"..entry.name, MemTex(entry.memory) .. " |cFFFFCC00/|r |cFFFFCC00" .. MemPerTex(entry.memory/total*100) .. " |cFFFFCC00 \| |r |cFFFFFFFF" .. MemPerTex(entry.cpu/CPUtotal*100))
    			else
    				GameTooltip:AddDoubleLine("|cFFFFFFFF" .. number + 1 .. ". |cFFFFCC00"..entry.name, MemTex(entry.memory) .. " |cFFFFCC00/|r |cFFFFCC00" .. MemPerTex(entry.memory/total*100) .. " |cFFFFCC00 \| |r |cFFFFFFFF" .. MemPerTex(entry.cpu/CPUtotal*100))
    			end
    			number = number + 1
    		end
    	end
      GameTooltip:AddLine("|cFFFFFFFF======================================================|r")
    	
      GameTooltip:AddDoubleLine("사용자 애드온 합계", TMemTex(total))
      GameTooltip:AddDoubleLine("블리자드 기본 UI 합계", WOWMemTex(collectgarbage("count") - total))
      GameTooltip:AddDoubleLine("총 합계", TMemTex(collectgarbage("count")))
    
    else
      GameTooltip:AddDoubleLine("상위 |cFFFFFFFF" .. ToolTipList .. "|r개의 애드온", "메모리 사용량 / 메모리 비율", 0, 0.6, 1, 1, 1, 0)

      GameTooltip:AddLine("|cFFFFFFFF======================================================|r")

      addons = {}
     	local number = 0
    	total = 0
      UpdateAddOnMemoryUsage()
      for i = 1, GetNumAddOns(), 1 do
        if GetAddOnMemoryUsage(i) > 0 then
          memory = GetAddOnMemoryUsage(i)
          entry = {name = GetAddOnInfo(i), memory = memory}
          table.insert(addons, entry)
          total = total + memory
        end
      end
    
      table.sort(addons, function(a, b) return a.memory > b.memory end)

      for _,entry in pairs(addons) do
    		if number < ToolTipList then
    			if number < 9 then
    				GameTooltip:AddDoubleLine("|cFFFFFFFF  " .. number + 1 .. ". |cFFFFCC00"..entry.name, MemTex(entry.memory) .. " |cFFFFCC00/|r |cFFFFCC00" .. MemPerTex(entry.memory/total*100))
    			else
    				GameTooltip:AddDoubleLine("|cFFFFFFFF" .. number + 1 .. ". |cFFFFCC00"..entry.name, MemTex(entry.memory) .. " |cFFFFCC00/|r |cFFFFCC00" .. MemPerTex(entry.memory/total*100))
    			end
    			number = number + 1
    		end
    	end
      GameTooltip:AddLine("|cFFFFFFFF======================================================|r")
  	
      GameTooltip:AddDoubleLine("사용자 애드온 합계", TMemTex(total))
      GameTooltip:AddDoubleLine("블리자드 기본 UI 합계", WOWMemTex(collectgarbage("count") - total))
      GameTooltip:AddDoubleLine("총 합계", TMemTex(collectgarbage("count")))
    end

  	GameTooltip:Show();
  	
  	ResetCPUUsage()
  	
  	if MemorySize ~= 0 and ((collectgarbage("count") - total)/1024 > MemorySize) then
  	  DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFFFF와우 기본 UI 메모리 사용량이 " .. MemTex(collectgarbage("count") - total) .. "넘었습니다.\n재접속 하길 권장합니다.");
  	end
	end
end

--function MenuListShow()

--end

function MemPerTex(Num)
	local AddonMem
	if Num >= 50 then
		AddonMem = "|cFFFF0000" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 40 then
		AddonMem = "|cFFFF4400" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 30 then
		AddonMem = "|cFFFF8800" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 20 then
		AddonMem = "|cFFFFAA00" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 10 then
		AddonMem = "|cFFFFCC00" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	elseif Num > 5 then
		AddonMem = "|cFFFFFF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	elseif Num > 2.5 then
		AddonMem = "|cFF88FF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	else
		AddonMem = "|cFF00FF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	end

	return(AddonMem)
end

function MemTex(Num)
	local AddonMem
	if Num > 10240 then
		Num = Num/1024
		AddonMem = "|cFFFF0000" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 5120 then
		Num = Num/1024
		AddonMem = "|cFFFF4400" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 2048 then
		Num = Num/1024
		AddonMem = "|cFFFF8800" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 1024 then
		Num = Num/1024
		AddonMem = "|cFFFFAA00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 786 then
		AddonMem = "|cFFFFCC00" .. string.format("%.2f", Num) .. " |cFFFFFFFFKiB"
	elseif Num > 512 then
		AddonMem = "|cFFFFFF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFKiB"
	elseif Num > 256 then
		AddonMem = "|cFF88FF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFKiB"
	else
		AddonMem = "|cFF00FF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFKiB"
	end

	return(AddonMem)
end

function TMemTex(Num)
  local AddonMem
  Num = Num/1024
  
  if Num > 85 then    
    AddonMem = "|cFFFF0000" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > 75 then
    AddonMem = "|cFFFF4400" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > 65 then
    AddonMem = "|cFFFF8800" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > 55 then
    AddonMem = "|cFFFFAA00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > 45 then
    AddonMem = "|cFFFFCC00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > 35 then
    AddonMem = "|cFFFFFF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > 25 then
    AddonMem = "|cFF88FF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  else
    AddonMem = "|cFF00FF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  end

  return(AddonMem)
end

function WOWMemTex(Num)
  local WOWMem
  Num = Num/1024
  
  if Num > SoW_Clock.MemSize * 1 then    
    WOWMem = "|cFFFF0000" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > SoW_Clock.MemSize * 0.9 then
    WOWMem = "|cFFFF4400" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > SoW_Clock.MemSize * 0.8 then
    WOWMem = "|cFFFF8800" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > SoW_Clock.MemSize * 0.7 then
    WOWMem = "|cFFFFAA00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > SoW_Clock.MemSize * 0.6 then
    WOWMem = "|cFFFFCC00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > SoW_Clock.MemSize * 0.5 then
    WOWMem = "|cFFFFFF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  elseif Num > SoW_Clock.MemSize * 0.4 then
    WOWMem = "|cFF88FF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  else
    WOWMem = "|cFF00FF00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
  end

  return(WOWMem)
end

-- 명령어 모음
SLASH_Clock1 = "/sc"
SLASH_Clock2 = "/ㅅㄱ"
SLASH_Clock3 = "/ㄴㅊ";
SLASH_Clock4 = "/swc";
SlashCmdList["Clock"] = function(cmd)
  msg = strtrim(cmd);
	cmd = gsub(msg, "(.*)@(.*)", "%1");
	argument = gsub(msg, "(.*)@(.*)", "%2");
	if cmd == "sc" or cmd == "scale" or cmd == "크기" or cmd == "ㅋㄱ" then
	  SoW_Clock.Scale = argument*1;
	  SoW_Clock_Frame:SetScale(SoW_Clock.Scale*1)
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF애드온의 크기 비율을 |r" .. argument .. "|cFFFFFFFF로 설정합니다.|r");
		
	elseif cmd == "ts" or cmd =="tipset" or cmd == "ㅈㄹ" or cmd == "정렬" then
	  SoW_Clock.TipSet = argument*1;
	  if (argument*1 == 0) then
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF목록을 메모리 비율순으로 정렬합니다.|r");
	  
	  else
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF목록을 CPU 비율순으로 정렬합니다.|r");
	  end
		
	elseif cmd == "tl" or cmd == "tiplist" or cmd == "ㅁㄹ" or cmd == "목록" then
	  SoW_Clock.TipList = argument*1;
	  if(SoW_Clock.TipList > 0) then
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF애드온 목록 갯수를 |r" .. SoW_Clock.TipList .. "|cFFFFFFFF개로 설정합니다.|r");
	  elseif(SoW_Clock.TipList == 0) then
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF애드온 툴팁을 비활성화합니다.|r");
	  else
	    SoW_Clock.TipList = 30;
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF애드온 목록 갯수를 기본값인 |r" .. SoW_Clock.TipList .. "|cFFFFFFFF개로 설정합니다.|r");
	  end
	  
	elseif cmd == "ms" or cmd =="memsize" or cmd == "ㅁㅋ" or cmd == "메모리크기" then
	  if (argument*1 >= 0) then
	    SoW_Clock.MemSize = argument*1;
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF와우 기본 UI 사용 메모리 경고량을 |r" .. SoW_Clock.MemSize .. "|cFFFFFFFFMiB로 설정합니다.|r");
	  
	  else
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF잘못된 값을 입력하였습니다. 확인 후 다시 입력하시기 바랍니다.");
	  end
		
	elseif (cmd == "tt" or cmd == "timetype" or cmd == "ㅅㅅ" or cmd == "시간표시설정") then
	  if (argument*1 == 0) then
		  DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF시간 표시방식을 |r|cFFFFFF0012시간 단위 및 오전/후 표시|r |cFFFFFFFF로 설정 합니다.|r");
		  SoW_Clock.TimeType = 0;
		
	  else
		  DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF시간 표시방식을 |r|cFFFFFF0024시간 단위 및 초 표시|r |cFFFFFFFF로 설정 합니다.|r");
		  SoW_Clock.TimeType = 1;
		end
		
	elseif cmd == "oc" or cmd == "ㅈㅅ" then
    if (argument*1 == 1) then
      SoW_Clock.OClock = true
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : 정시 알림을 사용합니다.");
    else
      SoW_Clock.OClock = false
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : 정시 알림을 해제합니다.");
	  end
	  
	elseif cmd == "ct" or cmd == "ㅊㅅ" then
	  if(argument*1 >= 0) then
	    SoW_Clock.CleanTime = argument*1
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFF00AAFF" .. argument*1 .. "|r분 간격으로 메모리 정리를 실행합니다.");
	  else
	    SoW_Clock.CleanTime = 0
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : 메모리 자동 정리 기능을 해제합니다.");
	  end
	  
	else
  	MemClear()
	end
end